package com.gree.mall.manager.logic.admin;

import com.aliyuncs.utils.StringUtils;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gree.mall.manager.bean.admin.AdminModuleTree;
import com.gree.mall.manager.exception.RemoteServiceException;
import com.gree.mall.manager.plus.entity.AdminModule;
import com.gree.mall.manager.plus.service.AdminModuleService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class AdminModuleLogic {

    @Autowired
    AdminModuleService adminModuleService;


    public void add(AdminModule adminModule){
        Integer level = 1;
        if(!adminModule.getParentId().equals("0")){
            AdminModule parent = adminModuleService.getById(adminModule.getParentId());
            if(parent == null){
                throw new RemoteServiceException("请选择正确的父级菜单");
            }
            level = parent.getLevel() + 1;

            parent.setType(1);
            parent.updateById();
        }
        Integer count = adminModuleService.lambdaQuery()
                .and(v -> v.eq(AdminModule::getCode, adminModule.getCode()).or().eq(AdminModule::getUrl, adminModule.getUrl()))
                .count();
        if(count > 0){
            throw new RemoteServiceException("code或者url重复");
        }
        adminModule.setLevel(level);
        adminModule.setCreateTime(new Date());
        adminModule.insert();
    }


    public void update(AdminModule adminModule){
        Integer level = 1;
        if(!adminModule.getParentId().equals("0")){
            AdminModule parent = adminModuleService.getById(adminModule.getParentId());
            if(parent == null){
                throw new RemoteServiceException("请选择正确的父级菜单");
            }
            level = parent.getLevel() + 1;
        }
        Integer count = adminModuleService.lambdaQuery()
                .and(v -> v.eq(AdminModule::getCode, adminModule.getCode()).or().eq(AdminModule::getUrl, adminModule.getUrl()))
                .ne(AdminModule::getModuleId,adminModule.getModuleId())
                .count();
        if(count > 0){
            throw new RemoteServiceException("code或者url重复");
        }
        adminModule.setLevel(level);
        adminModule.updateById();
    }


    public void delete(String id){
        adminModuleService.removeById(id);
    }


    public AdminModule detail(String id){
        return adminModuleService.getById(id);
    }


}
